(* the tg programming language *)
(* (C) 2008 Kim, Taegyoon *)

(* evaluator *)
open Lazy

type value =
    Int of int
  | String of string

(* (should be, given) *)
exception TypeError of string * string

let typeErrorInfo shouldbe given =
  "Type error: shouldbe " ^ shouldbe ^ ", given: " ^ given

(* let force a = a () *)

let int_of_value_l a =
  match force a with
      Int a' -> a'
    | String _ -> raise (TypeError ("Int", "String"))

(* forces a *)
let display a = (print_int (force a))

let display a =
  match force a with
      Int a' -> (print_int a')
    | String a' -> (print_string a')

let newline () = print_newline ()

let car a b = a
let cdr a b = b

let add a b = (lazy (Int ((int_of_value_l a) + (int_of_value_l b))))
let sub a b = (lazy (Int ((int_of_value_l a) - (int_of_value_l b))))
let mul a b = (lazy (Int ((int_of_value_l a) * (int_of_value_l b))))
let div a b = (lazy (Int ((int_of_value_l a) / (int_of_value_l b))))

let is_equal a b = (lazy ((force a) = (force b)))

let if_then_else cond then_p else_p =
  if (force cond) then
    then_p
  else
    else_p


